import { GlobalStoreConfig } from './GlobalStore.types';
import { ActionCollectionConfig, GlobalStoreAbstract, StateChangesParam, StateConfigCallbackParam, StateSetter } from 'react-hooks-global-states';
export declare class GlobalStore<TState, TMetadata = null, TStateMutator extends ActionCollectionConfig<TState, TMetadata> | StateSetter<TState> = StateSetter<TState>> extends GlobalStoreAbstract<TState, TMetadata, NonNullable<TStateMutator>> {
    protected config: GlobalStoreConfig<TState, TMetadata, TStateMutator>;
    constructor(state: TState, config?: GlobalStoreConfig<TState, TMetadata, TStateMutator>, actionsConfig?: TStateMutator | null);
    protected _onInitialize: ({ setState, getState, }: StateConfigCallbackParam<TState, TMetadata>) => void;
    protected _onChange: ({ getState, }: StateChangesParam<TState, TMetadata, NonNullable<TStateMutator>>) => void;
    /**
     * We set it to null so the instances of the GlobalStoreAbstract can override it.
     */
    protected onInitialize: any;
    protected onChange: any;
    /**
     * Instead of calling onInitialize and onChange directly, we call the _onInitialize and _onChange
     * This allows the concat the logic of the GlobalStore with the logic of the extension class.
     */
    protected onInit: (parameters: StateConfigCallbackParam<TState, TMetadata, TStateMutator>) => void;
    protected onStateChanged: (parameters: StateChangesParam<TState, TMetadata, TStateMutator>) => void;
}
